#include "ds18b20.h"
#define MAX_IN_SCURT  5   // numar maxim de secunde cit sursa sta in scurt apoi decupleaza
sbit LCD_RS at RB2_bit;
sbit LCD_EN at RB3_bit;
sbit LCD_D4 at RB4_bit;
sbit LCD_D5 at RB5_bit;
sbit LCD_D6 at RB6_bit;
sbit LCD_D7 at RB7_bit;

sbit LCD_RS_Direction at TRISB2_bit;
sbit LCD_EN_Direction at TRISB3_bit;
sbit LCD_D4_Direction at TRISB4_bit;
sbit LCD_D5_Direction at TRISB5_bit;
sbit LCD_D6_Direction at TRISB6_bit;
sbit LCD_D7_Direction at TRISB7_bit;
// End LCD module connections
char text0[]=" Sursa reglabila";
char text1[]="   By GeoMar";
char text2[]=" * ATENTIE !! *";
char text3[]=" Sursa in SCURT";
char lcd_buffer[16];

int timer0_flag=0;
 unsigned char ch,aux,flag_scurt=0,sec_scurt=0;
 unsigned int V_rd=0, A_rd=0;
 unsigned long u, i, power, res;
 unsigned char shift_LR = 0;
 


// Interrupt Handler
void interrupt()
{
  // Timer0 Interrupt - Freq = 168.75 Hz - Period = 0.005926 seconds
  if (INTCON.TMR0IF ==1) // timer 0 interrupt flag
  {
    timer0_flag++;
    INTCON.TMR0IF = 0;         // clear the flag
    INTCON.TMR0IE = 1;         // reenable the interrupt
    TMR0 = 0;           // reset the timer preset count
  }

}


 void print_scurt()
 {
  Lcd_Cmd(_LCD_CLEAR);
    Lcd_Out(1,1,text2);
   Lcd_Out(2,1,text3);
   Sound_Play(2000,300);
   Sound_Play(1000,200);
   Lcd_Cmd(_LCD_CLEAR);
   delay_ms(300);
 }

void main() {
//*********************intializari****************************
  ADCON1     = 0x88;                       // configure Vref, and analog channels
  TRISA      = 0xFF;                       // designate PORTA as input
  PORTB=0;
  TRISB=0;
  TRISD=0b11111101;
  PORTD.F1=0;
//Timer0 Registers Prescaler= 64 - TMR0 Preset = 0 - Freq = 168.75 Hz - Period = 0.005926 seconds
OPTION_REG.T0CS = 0;  // bit 5  TMR0 Clock Source Select bit...0 = Internal Clock (CLKO) 1 = Transition on T0CKI pin
OPTION_REG.T0SE = 0;  // bit 4 TMR0 Source Edge Select bit 0 = low/high 1 = high/low
OPTION_REG.PSA = 0;   // bit 3  Prescaler Assignment bit...0 = Prescaler is assigned to the Timer0
OPTION_REG.PS2 = 1;   // bits 2-0  PS2:PS0: Prescaler Rate Select bits
OPTION_REG.PS1 = 0;
OPTION_REG.PS0 = 1;
TMR0 = 0;             // preset for timer register

// Interrupt Registers
  INTCON = 0;           // clear the interrpt control register
  INTCON.TMR0IE = 1;        // bit5 TMR0 Overflow Interrupt Enable bit...1 = Enables the TMR0 interrupt
  INTCON.TMR0IF = 0;        // bit2 clear timer 0 interrupt flag
  INTCON.GIE = 1;           // bit7 global interrupt enable
  Lcd_Init();                        // Initialize LCD
  Sound_Init(&PORTB,0);

  Lcd_Cmd(_LCD_CLEAR);               // Clear display
  Lcd_Cmd(_LCD_CURSOR_OFF);          // Cursor off


 //******************main loop********************************
   Lcd_Cmd(_LCD_CLEAR);
   Sound_Play(1500,200);
   Lcd_Out(1,3,"* Loading *");
   delay_ms(200);
     LCD_Chr(2,1,0xFF);
   for(i=0;i<15;i++){
      LCD_Chr_CP(0xFF);
      delay_ms(200);
   }
   delay_ms(1000);
   Lcd_Cmd(_LCD_CLEAR);
   Sound_Play(1500,200);
   Lcd_Out(1,1,text0);
   Lcd_Out(2,1,text1);
   delay_ms(2000);
   Lcd_Cmd(_LCD_CLEAR);
   Sound_Play(1500,200);
   Lcd_Out(1,4,"Copyright");
   Lcd_Out(2,1,"* GeoMar - 2011*");
   delay_ms(1200);
   Lcd_Cmd(_LCD_CLEAR);

   
   PORTB.F1 = 1;   //pornire releu
   Sound_Play(1500,200);
   Sound_Play(1500,200);
while(1)
{     read:
      V_rd=ADC_read(1);                // get ADC value for U from channel 1
      u=(long)V_rd*3500;               // covert adc reading to milivolts
      u=u/1023;                            // 0..1023 -> 0-3500mV
      
      A_rd=ADC_read(0);               // get ADC value for I from channel 0
      i=(long)A_rd*3500;              // covert adc reading to milivolts
      i=i/1023;                            // 0..1023 -> 0-3500mV
      
      power=u*i/1000;
      res=u*100/i;
      
      
      if( i >= 3499 || u < 20){
          print_scurt();
           if(timer0_flag >= 169){
              sec_scurt++;
              timer0_flag = 0;
              }
           if(sec_scurt == MAX_IN_SCURT)
          {
           PORTB.F1 = 0;// oprire releu
           sec_scurt = 0;
             Lcd_Cmd(_LCD_CLEAR);
             Lcd_Out(1,1,"** ASTEPTATI! **");
             Lcd_Out(2,18,"*Eliminati Scurtul*");
             delay_ms(1000) ;
             for(shift_LR = 0 ;shift_LR < 38 ;shift_LR ++){
             Lcd_Cmd(_LCD_SHIFT_RIGHT);
             delay_ms(400) ;
             
           }
             delay_ms(1000) ;
             for(shift_LR = 0 ;shift_LR < 38 ;shift_LR ++){
             Lcd_Cmd(_LCD_SHIFT_LEFT);
             delay_ms(400) ;
           }
           delay_ms(10000); // loop infinit 20 sec
           Sound_Play(1500,200);
           Sound_Play(1300,120);
           Sound_Play(1400,50);
           Lcd_Cmd(_LCD_CLEAR);
           }
           goto read;
      }
      else{
      flag_scurt = 0;
      sec_scurt = 0;
      PORTB.F1 = 1; // pornire releu
      
     //aci vine codul din programul vechi pentru afisat tensiune si curent
    { Lcd_Cmd(_LCD_CLEAR);
      ch=u/1000;                           // extract 10.00 U digit
      if (ch==0)
       {
          LCD_Chr(1,1, 32);                // write empty space if digit is 0
        }
      else
        {
          LCD_Chr(1,1,48+ch);              // write ASCII digit at 1st row, 2nd column
        }
      ch=(u/100) %10;                      // extract 01.00 U digit
      LCD_Chr_CP(48+ch);                   // write ASCII digit at cursor point
      LCD_Chr_CP('.');                     // write '.' at cursor point
      ch=(u/10) %10;                       // extract 00.10 U digit
      LCD_Chr_CP(48+ch);                   // write ASCII digit at cursor point
      ch=u %10;                            // extract 00.01 U digit
      LCD_Chr_CP(48+ch);               // write ASCII digit at cursor point
      LCD_Chr_CP('V');                     // write 'V' at cursor point


      ch=i/1000;                           // extract 1.000 I digit
      LCD_Chr(1,10,48+ch);                 // write ASCII digit at 1st row, 10th column
      LCD_Chr_CP('.');                     // write '.' at cursor point
      
      ch=(i/100) %10;                      // extract 0.100 I digit

      LCD_Chr_CP(48+ch);                   // write ASCII digit at cursor point

      ch=(i/10) %10;                       // extract 0.010 I digit
      LCD_Chr_CP(48+ch);                   // write ASCII digit at cursor point

      ch=i %10;                            // extract 0.001 I digit
      LCD_Chr_CP(48+ch);               // write ASCII digit at cursor point
      LCD_Chr_CP('A');                     // write 'A' at cursor point
     }
     

      ch=power/1000;                       // extract 10.00 P digit
      if (ch==0)
        {
          LCD_Chr(2,1, 32);                // write empty space if digit is 0
        }
      else
        {
          LCD_Chr(2,1,48+ch);              // write ASCII digit at 2nd row, 2nd column
        }

      ch=(power/100) %10;                  // extract 01.00 P digit
      LCD_Chr_CP(48+ch);                   // write ASCII digit at cursor point
      LCD_Chr_CP('.');                     // write '.' at cursor point

      ch=(power/10) %10;                   // extract 0.10 P digit
      LCD_Chr_CP(48+ch);                   // write ASCII digit at cursor point

      ch=power %10;                        // extract 0.01 P digit
      LCD_Chr_CP(48+ch);                   // write ASCII digit at cursor point
      LCD_Chr_CP('W');                     // write 'W' at cursor point
      


  afisare_temperatura(2,9);
/*if(power==0)
        {
          LCD_Out(2,10,"  ");              // write empty space
          LCD_Chr_CP(243);                 // write 'infinity' at cursor point
          LCD_Out(2,13,"  ");              // write empty space
          LCD_Chr_CP(244);                 // write 'ohm' at cursor point
        }
      else
        {
          res=u*100/i;
          if(res>=10000)
            {
              LCD_Out(2,10," > 1K");       // write " > 1K"
              LCD_Chr_CP(244);             // write 'ohm' at cursor point
            }
          else
            {
              ch=res/1000;                 // extract 100.0 R digit
              if (ch==0)
                {
                  LCD_Chr(2,10, 32);       // write empty space if digit is 0
                }
              else
                {
                  LCD_Chr(2,10,48+ch);     // write ASCII digit at 2nd row, 10th column
                }

              ch=(res/100) %10;            // extract 010.0 R digit
              if (ch==0 && res<=99)
                {
                  LCD_Chr_CP(32);          // write empty space if digit is 0
                }
              else
                {
                  LCD_Chr_CP(48+ch);       // write ASCII digit at cursor point
                }

              ch=(res/10) %10;             // extract 001.0 R digit
              LCD_Chr_CP(48+ch);           // write ASCII digit at cursor point
              LCD_Chr_CP('.');             // write '.' at cursor point

              ch=res %10;                  // extract 000.1 R digit
              LCD_Chr_CP(48+ch);           // write ASCII digit at cursor point
              LCD_Chr_CP(244);             // write 'ohm' at cursor point
            }
        }
        // aci se termina codul vechi*/
    //delay_ms(800);
    }
}


}